use std::marker::PhantomData;

#[repr(C)]
#[derive(Debug, Clone, Copy, PartialEq, Eq)]
pub struct TEnumAsByte<T> {
    inner: u8,
    phantom: PhantomData<T>,
}

impl<T> TEnumAsByte<T> {
    pub fn new(value: T) -> Self {
        Self {
            inner: unsafe { *core::mem::transmute::<_, *const u8>(&value as *const T) },
            phantom: PhantomData,
        }
    }

    pub fn as_enum(&self) -> &T {
        unsafe { &*core::mem::transmute::<_, *const T>(&self.inner as *const u8) }
    }
    pub fn as_mut_enum(&mut self) -> &mut T {
        unsafe { &mut *core::mem::transmute::<_, *mut T>(&mut self.inner as *mut u8) }
    }
}

#[derive(Debug)]
pub struct FText([u8; 0x28]);
